options(width=120)

load(".Rdata.pres2simnlN");

set.seed(19342);
if (!exists("multinomRob"))
	library(multinomRob, lib.loc="/home/wrm1/lib/R/");

asc <- function(x) { as.character(x) }

gen2004u$county <- factor(toupper(asc(gen2004u$county)));

showout <- function(cname) {
  zall[[cname]]$residuals.student[zall[[cname]]$weights[,2]==0]
}

cnames <- c(
"ADAMS", "ALLEN", "ASHLAND", "ASHTABULA", "ATHENS", "AUGLAIZE",
"BELMONT", "BROWN", "BUTLER", "CARROLL", "CHAMPAIGN", "CLARK",
"CLERMONT", "CLINTON", "COLUMBIANA", "COSHOCTON", "CRAWFORD",
"CUYAHOGA", "DARKE", "DEFIANCE", "DELAWARE", "ERIE", "FAIRFIELD",
"FAYETTE", "FRANKLIN", "FULTON", "GALLIA", "GEAUGA", "GREENE",
"GUERNSEY", "HAMILTON", "HANCOCK", "HARDIN", "HARRISON", "HENRY",
"HIGHLAND", "HOCKING", "HOLMES", "HURON", "JACKSON", "JEFFERSON",
"KNOX", "LAKE", "LAWRENCE", "LICKING", "LOGAN", "LORAIN", "LUCAS",
"MADISON", "MAHONING", "MARION", "MEDINA", "MEIGS", "MERCER", "MIAMI",
"MONROE", "MONTGOMERY", "MORGAN", "MORROW", "MUSKINGUM", "NOBLE",
"OTTAWA", "PAULDING", "PERRY", "PICKAWAY", "PIKE", "PORTAGE",
"PREBLE", "PUTNAM", "RICHLAND", "ROSS", "SANDUSKY", "SCIOTO",
"SENECA", "SHELBY", "STARK", "SUMMIT", "TRUMBULL", "TUSCARAWAS",
"UNION", "VANWERT", "VINTON", "WARREN", "WASHINGTON", "WAYNE",
"WILLIAMS", "WOOD", "WYANDOT" );

for (i in 1:88) {
  tdat <- gen2004u[gen2004u$countynum==i,];

  cat("county", i, ":", cnames[i], "\n");
  print( summary(zall[[i]]) );
  if (!is.null(zall[[i]]$weights) && any(zall[[i]]$weights[,2]==0)) {
    print(tdat[zall[[i]]$weights[,2]==0,c(1:4,12:18,26:27)]);
    print(showout(cnames[i]));

    cat(paste(
      asc(tdat[zall[[i]]$weights[,2]==0,c(2)]), " & ",
      asc(tdat[zall[[i]]$weights[,2]==0,"stateprecinctcode"]), " & ",
      sapply(showout(i), function(n){sprintf(" %5.2f \\\\\n", n)})
    ));
  }
  if (!is.null(zall[[i]]$residuals.student) && any(abs(zall[[i]]$residuals.student)>3)) {
    idx <- abs(zall[[i]]$residuals.student)>3;
    bigresids <- zall[[i]]$residuals.student[idx];
    mat <- cbind(tdat[idx,c(2:4)],bigresids);
    dimnames(mat)[[2]] <- c("county","SPC","precinct","std.resid");
    print(mat);
  }
}
