# production

load(".Rdata.turnoutmach2mOd");

set.seed(19342);
if (!exists("multinomRob"))
	library(multinomRob, lib.loc="/home/wrm1/lib/R/");

asc <- function(x) { as.character(x) }

logit <- function(x) {
  eps <- .0001;
  z <- ifelse(x<=0, eps, ifelse(x>=1, 1-eps, x));
  return( log(z/(1-z)) );
}

showout <- function(cname) {
  zall[[cname]]$residuals.student[zall[[cname]]$weights[,2]==0]
}

model1 <- list(votescast04 ~ machperreg,
              nonvote ~ -1
              );

umachtype <- c("dre", "optprecinct", "optcentral", "punchcard");
for (i in names(zall)) {
  tdat <- gen2004v[i == asc(gen2004v$machtype),];
  print(i);

  print(unique(asc(tdat$county)));

  print(summary(zall[[i]]));
  if (!is.null(zall[[i]]$weights) && any(zall[[i]]$weights[,2]==0)) {
    print(tdat[zall[[i]]$weights[,2]==0,c(1:4,12:18,26:27)]);
    print(showout(i));
  }

  cat(pset <- paste(
    asc(tdat[zall[[i]]$weights[,2]==0,c(2)]), " & ",
    asc(tdat[zall[[i]]$weights[,2]==0,c(3)]), " & ",
    sapply(showout(i), function(n){sprintf(" %5.2f \\\\\n", n)})
  ));
}
