# production

load(".Rdata.wardturnout1mN");

set.seed(19342);
if (!exists("multinomRob"))
	library(multinomRob, lib.loc="/home/wrm1/lib/R/");

logit <- function(x) {
  z <- ifelse(x<=0, .0000001, ifelse(x>=1, 1-.0000001, x));
  return( log(z/(1-z)) );
}

asc <- function(x) { as.character(x) }

ucounty <- c("CUYAHOGA", "FRANKLIN", "HAMILTON", "LUCAS");
uCounty <- c("Cuyahoga", "Franklin", "Hamilton", "Lucas");

showout <- function(cname) {
  zall[[cname]]$residuals.student[zall[[cname]]$weights[,2]==0]
}

model1 <- list(votescast04 ~ vlogit02,
              nonvote04 ~ -1
              );

for (i in 1:4) {
  tdat <- wards[asc(wards$county)==ucounty[i],];
  print(uCounty[i]);

  print(summary(zall[[ucounty[i]]]));
  if (!is.null(zall[[ucounty[i]]]$weights) && any(zall[[ucounty[i]]]$weights[,2]==0)) {
    print(tdat[zall[[ucounty[i]]]$weights[,2]==0,c(1:11)]);
    print(showout(ucounty[i]));

    cat(paste(
      asc(tdat[zall[[ucounty[i]]]$weights[,2]==0,c(1)]), " & ",
      asc(tdat[zall[[ucounty[i]]]$weights[,2]==0,"city"]),
      asc(tdat[zall[[ucounty[i]]]$weights[,2]==0,"ward"]), " & ",
      sapply(showout(ucounty[i]), function(n){sprintf(" %5.2f \\\\\n", n)})
    ));
  }
}

