# production

gen2004 <- read.csv("general2004_rev_prod2.csv");

#> dim(gen2004)
#[1] 11569   115
#> names(gen2004)
#  [1] "countynum"              "county"                 "stateprecinctcode"
#  [4] "precinctname"           "split"                  "dist.congress"
#  [7] "dist.senateoh"          "dist.houseoh"           "dist.schoolboard"
# [10] "dist.courtofappeals"    "regvoters04"            "votescast04"
# [13] "kerry04"                "bush04"                 "indeppresa04"
# [16] "indeppresb04"           "dem.ussenate04"         "repub.ussenate04"
# [19] "chiefjusticea04"        "chiefjusticeb04"        "justice1a04"
# [22] "justice1b04"            "justice204"             "justice3a04"
# [25] "justice3b04"            "issueyes04"             "issueno04"
# [28] "dem.congress04"         "repub.congress04"       "indep.congress04"
# [31] "dem.senateoh04"         "repub.senateoh04"       "indep.senateoh04"
# [34] "dem.houseoh04"          "repub.houseoh04"        "indepa.houseoh04"
# [37] "indepb.houseoh04"       "boardofeda04"           "boardofedb04"
# [40] "boardofedc04"           "boardofedd04"           "courtofappeals1a04"
# [43] "courtofappeals1b04"     "courtofappeals2a04"     "courtofappeals2b04"
# [46] "courtofappeals3a04"     "courtofappeals3b04"     "courtofappeals4a04"
# [49] "courtofappeals4b04"     "courtofappeals4c04"     "courtofappeals5a04"
# [52] "courtofappeals5b04"     "courtofappeals6a04"     "courtofappeals6b04"
# [55] "constantboundaries0204" "absentee"               "federal"
# [58] "technology04"           "technology00"           "resid.pres04"
# [61] "resid.ussenate04"       "resid.scj04"            "mainsplit"
# [64] "precinctname02"         "regvoters02"            "votescast02"
# [67] "gov.dem02"              "gov.rep02"              "gov.ind02"
# [70] "precinctname03"         "regvoters03"            "votescast03"
# [73] "yes03"                  "no03"                   "FIPS"
# [76] "CNTY.VTD"               "CD108"                  "STHSE02"
# [79] "STSEN02"                "VAP"                    "VANHW"
# [82] "VANHAA"                 "VANHAP"                 "VANHNA"
# [85] "VANHOTHER"              "VAHISP"                 "PCT.VANHW"
# [88] "PCT.VANHAA"             "PCT.VANHAP"             "PCT.VANHNA"
# [91] "PCT.VANHO"              "PCT.VAHISP"             "MT.A.VAP"
# [94] "MT.B.VAP"               "MT.C.VAP"               "MT.D.VAP"
# [97] "MT.E.VAP"               "MT.F.VAP"               "MT.G.VAP"
#[100] "MT.H.VAP"               "MT.I.VAP"               "MT.J.VAP"
#[103] "MT.NA.VAP"              "MT.A.PCT"               "MT.B.PCT"
#[106] "MT.C.PCT"               "MT.D.PCT"               "MT.E.PCT"
#[109] "MT.F.PCT"               "MT.G.PCT"               "MT.H.PCT"
#[112] "MT.I.PCT"               "MT.J.PCT"               "MT.NA.PCT"
#[115] "machines04"

gen2004$machtype <- factor(
  ifelse(gen2004$technology04==1,"Punchcard",
  ifelse(gen2004$technology04==2,"DRE",
  ifelse(gen2004$technology04==3,"Opt Precinct",
  ifelse(gen2004$technology04==4,"Opt Central", NA)))) );

gen2004$machperreg <- gen2004$machines04 / gen2004$regvoters04 ;

asc <- function(x) { as.character(x) }

logit <- function(x) {
  eps <- .0001;
  z <- ifelse(x<=0, eps, ifelse(x>=1, 1-eps, x));
  return( log(z/(1-z)) );
}

asc <- function(x) { as.character(x) }

gen2004$county <- factor(toupper(asc(gen2004$county)));

gen2004$machtype <- factor(
  ifelse(asc(gen2004$county)=="CUYAHOGA", "PCuyahoga",
  ifelse(asc(gen2004$county)=="HAMILTON", "PHamilton",
  ifelse(gen2004$technology04==1,"Punchcard",
  ifelse(gen2004$technology04==2,"DRE",
  ifelse(gen2004$technology04==3,"Optical Precinct",
  ifelse(gen2004$technology04==4,"Optical Central", NA)))))) );

grep("FEDERAL", asc(gen2004$precinctname))
grep("ABSENTEE", asc(gen2004$precinctname))

keepidx <- gen2004$votescast04>0 & gen2004$kerry04+gen2004$bush04>0 &
           gen2004$issueyes04+gen2004$issueno04>0 &
           !is.na(gen2004$PCT.VANHAA) ;
gen2004u <- gen2004[keepidx,];

grep("FEDERAL", asc(gen2004u$precinctname))
grep("ABSENTEE", asc(gen2004u$precinctname))

gen2004u$nonvote <- gen2004u$regvoters04 - gen2004u$votescast04;

gen2004u$VANHAAprop <- gen2004u$PCT.VANHAA / 100; # + (1/2)/gen2004u$VAP;
gen2004u$VANHAAlogit <- logit(gen2004u$VANHAAprop);

gen2004u$VAHISPprop <- gen2004u$PCT.VAHISP / 100; # + (1/2)/gen2004u$VAP;
gen2004u$VAHISPlogit <- logit(gen2004u$VAHISPprop);

gen2004u$I1prop <- gen2004u$issueyes04 / gen2004u$votescast04 ;
gen2004u$I1logit <- logit(gen2004u$I1prop) ;

gen2004u$demsenprop <- gen2004u$dem.ussenate04 / gen2004u$votescast04 ;
gen2004u$demsenlogit <- logit(gen2004u$demsenprop) ;

gen2004u$pres4 <- gen2004u$kerry04+gen2004u$bush04+
                  gen2004u$indeppresa04+gen2004u$indeppresb04;
gen2004u$resid4 <- gen2004u$votescast04 - gen2004u$pres4;

quantile(gen2004u$resid4/gen2004u$votescast04);

sum(gen2004u$resid4/gen2004u$votescast04 < 0);
gen2004u[gen2004u$resid4/gen2004u$votescast04 < 0,c(2:5,11:16)]
sum(gen2004u$resid4/gen2004u$votescast04 > .2);
sum(gen2004u$resid4/gen2004u$votescast04 > .1);

keepidx <- gen2004u$resid4 >= 0 &
           !is.na(gen2004u$machines04) & gen2004u$machines04 > 0;
gen2004v <- gen2004u[keepidx,];

quantile(gen2004v$resid4/gen2004v$votescast04);

gen2004v$machperreg <- gen2004v$machines04 / gen2004v$regvoters04;
gen2004v$logmachperreg <- log(gen2004v$machperreg);

gen2004v$residrate <- gen2004v$resid4 / gen2004v$votescast04;

gen2004v$toprop04 <- gen2004v$votescast04/gen2004v$regvoters04;

gen2004v$kerryprop <- gen2004v$kerry04/gen2004v$pres4;

xtabs(resid4 ~ machtype, gen2004v)/xtabs(votescast04 ~ machtype, gen2004v);
xtabs(residrate ~ machtype, gen2004v)/xtabs(~ machtype, gen2004v);

for (i in unique(asc(gen2004v$machtype))) {
  tdat <- gen2004v[asc(gen2004v$machtype) == i,];
  print(i);
  print(quantile(tdat$residrate));
}
