# production

load(".Rdata.residmach6mN");

set.seed(19342);
if (!exists("multinomRob"))
	library(multinomRob, lib.loc="/home/wrm1/lib/R/");

asc <- function(x) { as.character(x) }

logit <- function(x) {
  eps <- .0001;
  z <- ifelse(x<=0, eps, ifelse(x>=1, 1-eps, x));
  return( log(z/(1-z)) );
}

showout <- function(cname) {
  zall[[cname]]$residuals.student[zall[[cname]]$weights[,2]==0]
}

model1 <- list(resid4 ~ machperreg + VANHAAprop,
              pres4 ~ -1
              );

umachtype <- c("dre", "optprecinct", "optcentral", "punchcard");
for (i in umachtype) {
  tdat <- gen2004v[i == asc(gen2004v$machtype),];
  print(i);

  if (!is.null(zall[[i]]$weights) && any(zall[[i]]$weights[,2]==0)) {

    w0 <- zall[[i]]$weights[,2]==0;
    tdat$kerryprop <- tdat$kerry04/(tdat$kerry04+tdat$bush04);
    tlm <- glm(w0 ~ kerryprop, tdat, family=binomial());
    print(summary(tlm));
  }
}

for (i in umachtype) {
  tdat <- gen2004v[i == asc(gen2004v$machtype),];
  print(i);

  if (!is.null(zall[[i]]$weights) && any(zall[[i]]$weights[,2]==0)) {

    w0 <- zall[[i]]$weights[,2]==0;
    tdat$kerryprop <- tdat$kerry04/(tdat$kerry04+tdat$bush04);
    tdat$residprop <- tdat$resid4/tdat$votescast04;
    print(median(tdat$residprop[w0]));
    print(median(tdat$residprop[!w0]));
    print(summary(lm(residprop ~ w0, tdat)));
    print(xtabs(resid4 ~ w0, tdat));
  }
}
