# production

gen2004 <- read.csv("general2004_rev_prod2.csv");

#> dim(gen2004)
#[1] 11569   115
#> names(gen2004)
#  [1] "countynum"              "county"                 "stateprecinctcode"
#  [4] "precinctname"           "split"                  "dist.congress"
#  [7] "dist.senateoh"          "dist.houseoh"           "dist.schoolboard"
# [10] "dist.courtofappeals"    "regvoters04"            "votescast04"
# [13] "kerry04"                "bush04"                 "indeppresa04"
# [16] "indeppresb04"           "dem.ussenate04"         "repub.ussenate04"
# [19] "chiefjusticea04"        "chiefjusticeb04"        "justice1a04"
# [22] "justice1b04"            "justice204"             "justice3a04"
# [25] "justice3b04"            "issueyes04"             "issueno04"
# [28] "dem.congress04"         "repub.congress04"       "indep.congress04"
# [31] "dem.senateoh04"         "repub.senateoh04"       "indep.senateoh04"
# [34] "dem.houseoh04"          "repub.houseoh04"        "indepa.houseoh04"
# [37] "indepb.houseoh04"       "boardofeda04"           "boardofedb04"
# [40] "boardofedc04"           "boardofedd04"           "courtofappeals1a04"
# [43] "courtofappeals1b04"     "courtofappeals2a04"     "courtofappeals2b04"
# [46] "courtofappeals3a04"     "courtofappeals3b04"     "courtofappeals4a04"
# [49] "courtofappeals4b04"     "courtofappeals4c04"     "courtofappeals5a04"
# [52] "courtofappeals5b04"     "courtofappeals6a04"     "courtofappeals6b04"
# [55] "constantboundaries0204" "absentee"               "federal"
# [58] "technology04"           "technology00"           "resid.pres04"
# [61] "resid.ussenate04"       "resid.scj04"            "mainsplit"
# [64] "precinctname02"         "regvoters02"            "votescast02"
# [67] "gov.dem02"              "gov.rep02"              "gov.ind02"
# [70] "precinctname03"         "regvoters03"            "votescast03"
# [73] "yes03"                  "no03"                   "FIPS"
# [76] "CNTY.VTD"               "CD108"                  "STHSE02"
# [79] "STSEN02"                "VAP"                    "VANHW"
# [82] "VANHAA"                 "VANHAP"                 "VANHNA"
# [85] "VANHOTHER"              "VAHISP"                 "PCT.VANHW"
# [88] "PCT.VANHAA"             "PCT.VANHAP"             "PCT.VANHNA"
# [91] "PCT.VANHO"              "PCT.VAHISP"             "MT.A.VAP"
# [94] "MT.B.VAP"               "MT.C.VAP"               "MT.D.VAP"
# [97] "MT.E.VAP"               "MT.F.VAP"               "MT.G.VAP"
#[100] "MT.H.VAP"               "MT.I.VAP"               "MT.J.VAP"
#[103] "MT.NA.VAP"              "MT.A.PCT"               "MT.B.PCT"
#[106] "MT.C.PCT"               "MT.D.PCT"               "MT.E.PCT"
#[109] "MT.F.PCT"               "MT.G.PCT"               "MT.H.PCT"
#[112] "MT.I.PCT"               "MT.J.PCT"               "MT.NA.PCT"
#[115] "machines04"

gen2004$machtype <- factor(
  ifelse(gen2004$technology04==1,"Punchcard",
  ifelse(gen2004$technology04==2,"DRE",
  ifelse(gen2004$technology04==3,"Opt Precinct",
  ifelse(gen2004$technology04==4,"Opt Central", NA)))) );

gen2004$machperreg <- gen2004$machines04 / gen2004$regvoters04 ;

asc <- function(x) { as.character(x) }

logit <- function(x) {
  eps <- .0001;
  z <- ifelse(x<=0, eps, ifelse(x>=1, 1-eps, x));
  return( log(z/(1-z)) );
}

gen2004$county <- factor(toupper(asc(gen2004$county)));

gen2004$machtype <- factor(
  ifelse(asc(gen2004$county)=="CUYAHOGA", "PCuyahoga",
  ifelse(asc(gen2004$county)=="HAMILTON", "PHamilton",
  ifelse(gen2004$technology04==1,"Punchcard",
  ifelse(gen2004$technology04==2,"DRE",
  ifelse(gen2004$technology04==3,"Opt Precinct",
  ifelse(gen2004$technology04==4,"Opt Central", NA)))))) );

keepidx <- !is.na(gen2004$machines04) & gen2004$machines04 > 0;
gen2004v <- gen2004[keepidx,];

#umachtype <- unique(asc(gen2004v$machtype));
umachtype <- c("DRE", "Opt Precinct", "Opt Central", "Punchcard", "PCuyahoga", "PHamilton");
for (i in umachtype) {
  tdat <- gen2004v[i == asc(gen2004v$machtype),];
  print(i);
  print(unique(asc(tdat$county)));
}
